SystemOrganization addCategory: #'TAIS-TestReloj'!
SystemOrganization addCategory: #'TAIS-Reloj'!

Object subclass: #Manesilla
	instanceVariableNames: 'valor max min periodo sig'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TAIS-Reloj'!

!Manesilla methodsFor: 'logic' stamp: 'juliohurtado 4/27/2012 12:39'!
avanzar
	valor := valor + periodo.
	(valor >= max) ifTrue: [valor := min. (sig isNil) ifFalse: [sig avanzar]].
	^ self! !

!Manesilla methodsFor: 'accessing' stamp: 'juliohurtado 4/27/2012 13:02'!
getHora
	"comment stating purpose of message"
      
      (sig isNil) ifTrue: [^ valor asString ] ifFalse: [^ sig getHora, ':', valor asString] .

	! !

!Manesilla methodsFor: 'accessing' stamp: 'juliohurtado 4/27/2012 11:58'!
max

	^ max! !

!Manesilla methodsFor: 'accessing' stamp: 'juliohurtado 4/27/2012 11:58'!
max: anObject

	max := anObject! !

!Manesilla methodsFor: 'accessing' stamp: 'juliohurtado 4/27/2012 11:58'!
min

	^ min! !

!Manesilla methodsFor: 'accessing' stamp: 'juliohurtado 4/27/2012 11:58'!
min: anObject

	min := anObject! !

!Manesilla methodsFor: 'accessing' stamp: 'juliohurtado 4/27/2012 11:58'!
periodo

	^ periodo! !

!Manesilla methodsFor: 'accessing' stamp: 'juliohurtado 4/27/2012 11:58'!
periodo: anObject

	periodo := anObject! !

!Manesilla methodsFor: 'accessing' stamp: 'juliohurtado 4/27/2012 12:06'!
sig

	^ sig! !

!Manesilla methodsFor: 'accessing' stamp: 'juliohurtado 4/27/2012 12:06'!
sig: anObject

	sig := anObject! !

!Manesilla methodsFor: 'accessing' stamp: 'juliohurtado 4/27/2012 11:58'!
valor

	^ valor! !

!Manesilla methodsFor: 'accessing' stamp: 'juliohurtado 4/27/2012 11:58'!
valor: anObject

	valor := anObject! !

Object subclass: #PPanelReloj
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TAIS-Reloj'!

Object subclass: #RReloj
	instanceVariableNames: 'menor estado'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TAIS-Reloj'!

!RReloj methodsFor: 'logic' stamp: 'juliohurtado 4/27/2012 13:09'!
correr: veces
	"comment stating purpose of message"
	| i |
	 i:= 0.
	menor isNil ifFalse: [[i<veces] whileTrue: [ menor avanzar]].! !

!RReloj methodsFor: 'accessing' stamp: 'juliohurtado 4/27/2012 12:44'!
estado

	^ estado! !

!RReloj methodsFor: 'accessing' stamp: 'juliohurtado 4/27/2012 12:44'!
estado: anObject

	estado := anObject! !

!RReloj methodsFor: 'accessing' stamp: 'juliohurtado 4/27/2012 12:56'!
getHora
	"comment stating purpose of message"
      menor isNil ifFalse: [^ menor getHora] ifTrue:[^menor].! !

!RReloj methodsFor: 'accessing' stamp: 'juliohurtado 4/27/2012 12:44'!
menor

	^ menor! !

!RReloj methodsFor: 'accessing' stamp: 'juliohurtado 4/27/2012 12:44'!
menor: anObject

	menor := anObject! !

TestCase subclass: #TestReloj
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TAIS-TestReloj'!

!TestReloj methodsFor: 'testing' stamp: 'juliohurtado 4/27/2012 12:37'!
testLogicaAvanzar
	"this is a simple test"
	| manesilla1 manesilla2 |
	manesilla1:= Manesilla new valor:59; max:60;min:0; periodo:1.
	manesilla2:= Manesilla new valor:0; max:60;min:0; periodo:1.
	manesilla1 sig: manesilla2; avanzar.
	self assert: manesilla1 valor = 0.
	self assert: manesilla2 valor = 1
	
! !

!TestReloj methodsFor: 'testing' stamp: 'juliohurtado 4/27/2012 12:37'!
testLogicaManecilla
	"this is a simple test"
	| manesilla1 manesilla2 |
	manesilla1:= Manesilla new valor:59; max:60;min:0; periodo:1.
	manesilla2:= Manesilla new valor:0; max:60;min:0; periodo:1.
	self assert: manesilla1 avanzar valor =  manesilla2 valor.
	
! !

!TestReloj methodsFor: 'testing' stamp: 'juliohurtado 4/27/2012 11:36'!
testMayor
	"this is a simple test"
	self assert: (2> 8) not
! !

!TestReloj methodsFor: 'testing' stamp: 'juliohurtado 4/27/2012 11:40'!
testNewManecilla
	"this is a simple test"
	self assert: (Manesilla new isNil) not
! !

!TestReloj methodsFor: 'testing' stamp: 'juliohurtado 4/27/2012 12:05'!
testNewManecillaParam
	"this is a simple test"
	| manesillaSig |
	self assert: (Manesilla new valor:0; max:60;min:0; periodo:1; isNil) not.
	manesillaSig := Manesilla new valor:0; max:60;min:0; periodo:1.
	self assert: (Manesilla new valor:0; max:60;min:0; periodo:1; sig:manesillaSig; isNil) not
	
! !

!TestReloj methodsFor: 'testing' stamp: 'juliohurtado 4/27/2012 13:09'!
testReloj
	"comment stating purpose of message"
	| manesilla1 manesilla2 relojito|
	manesilla2:= Manesilla new valor:0; max:60;min:0; periodo:1.
	manesilla1:= Manesilla new valor:58; max:60;min:0; periodo:1;sig:manesilla2.
	relojito := RReloj new menor:manesilla1.
	self assert: relojito isNil not.
	relojito correr:2.
	self assert: relojito getHora = '1:0'
	! !
